# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from . import utilities, tables

class Folder(pulumi.CustomResource):
    custom_attributes: pulumi.Output[dict]
    """
    Map of custom attribute ids to attribute 
    value strings to set for folder. See [here][docs-setting-custom-attributes]
    for a reference on how to set values for custom attributes.
    """
    datacenter_id: pulumi.Output[str]
    """
    The ID of the datacenter the folder will be created in.
    Required for all folder types except for datacenter folders. Forces a new
    resource if changed.
    """
    path: pulumi.Output[str]
    """
    The path of the folder to be created. This is relative to
    the root of the type of folder you are creating, and the supplied datacenter.
    For example, given a default datacenter of `default-dc`, a folder of type
    `vm` (denoting a virtual machine folder), and a supplied folder of
    `terraform-test-folder`, the resulting path would be
    `/default-dc/vm/terraform-test-folder`.
    """
    tags: pulumi.Output[list]
    """
    The IDs of any tags to attach to this resource. See
    [here][docs-applying-tags] for a reference on how to apply tags.
    """
    type: pulumi.Output[str]
    """
    The type of folder to create. Allowed options are
    `datacenter` for datacenter folders, `host` for host and cluster folders,
    `vm` for virtual machine folders, `datastore` for datastore folders, and
    `network` for network folders. Forces a new resource if changed.
    """
    def __init__(__self__, resource_name, opts=None, custom_attributes=None, datacenter_id=None, path=None, tags=None, type=None, __name__=None, __opts__=None):
        """
        The `vsphere_folder` resource can be used to manage vSphere inventory folders.
        The resource supports creating folders of the 5 major types - datacenter
        folders, host and cluster folders, virtual machine folders, datastore folders,
        and network folders.
        
        Paths are always relative to the specific type of folder you are creating.
        Subfolders are discovered by parsing the relative path specified in `path`, so
        `foo/bar` will create a folder named `bar` in the parent folder `foo`, as long
        as that folder exists.
        
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[dict] custom_attributes: Map of custom attribute ids to attribute 
               value strings to set for folder. See [here][docs-setting-custom-attributes]
               for a reference on how to set values for custom attributes.
        :param pulumi.Input[str] datacenter_id: The ID of the datacenter the folder will be created in.
               Required for all folder types except for datacenter folders. Forces a new
               resource if changed.
        :param pulumi.Input[str] path: The path of the folder to be created. This is relative to
               the root of the type of folder you are creating, and the supplied datacenter.
               For example, given a default datacenter of `default-dc`, a folder of type
               `vm` (denoting a virtual machine folder), and a supplied folder of
               `terraform-test-folder`, the resulting path would be
               `/default-dc/vm/terraform-test-folder`.
        :param pulumi.Input[list] tags: The IDs of any tags to attach to this resource. See
               [here][docs-applying-tags] for a reference on how to apply tags.
        :param pulumi.Input[str] type: The type of folder to create. Allowed options are
               `datacenter` for datacenter folders, `host` for host and cluster folders,
               `vm` for virtual machine folders, `datastore` for datastore folders, and
               `network` for network folders. Forces a new resource if changed.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if not resource_name:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(resource_name, str):
            raise TypeError('Expected resource name to be a string')
        if opts and not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        __props__['custom_attributes'] = custom_attributes

        __props__['datacenter_id'] = datacenter_id

        if path is None:
            raise TypeError("Missing required property 'path'")
        __props__['path'] = path

        __props__['tags'] = tags

        if type is None:
            raise TypeError("Missing required property 'type'")
        __props__['type'] = type

        super(Folder, __self__).__init__(
            'vsphere:index/folder:Folder',
            resource_name,
            __props__,
            opts)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

